// global variables provided to the pixel shader
varying vec3 normal;      // global variable normal vector
varying vec3 light;       // global variable light vector
varying vec2 texcoords;   // texture coordinates

void main()
{
    // projection on the screen by a product with the transformation matrix
    gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
    
    // calculates the normal vector in global coordinates
    normal = normalize(gl_NormalMatrix * gl_Normal);
    
    // calculate the global coordinates but not planned
    vec4 pointPosition = gl_ModelViewMatrix * gl_Vertex;
    
    // light position
    vec4 lightPosition = gl_LightSource[0].position;
    
    // calculate the light vector in this summit
    light = normalize(vec3(lightPosition - pointPosition));
    
    // calculate the texture coordinates of this vertex
    texcoords = vec2(gl_MultiTexCoord0);
}